#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>
using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"


/*==============================

  U P D A T E _ V A R _ M O D E

  ===============================*/
void ExQuant::update_var_mode()
{
  if ((num_act_sgnl_cubes == 0) && (num_assgn_xvars == 0))
    yvar_mode = true;
  else   {
    if (curr_depth == -1) return;
    Node &n = Tree_path[curr_depth];
    if ((alg_state != BPE) && (Var_state[n.var-1].xvar == 0))	{
      p();
      printf("gcount = %ld\n",gcount);
      print_alg_state(false);
      printf("num_assgn_xvars = %d\n",num_assgn_xvars);
      printf("real number of assigned int vars = %d\n",real_num_assgn_int_vars());
      printf("failed to update var mode: some intern. variables are not red. \n");
      printf("num_act_sgnl_cubes = %d\n",num_act_sgnl_cubes);
      printf("init_ncubes = %d\n",init_ncubes);
      print_sgnl_cubes(true);
      exit(1);
    }
  }
} /* end of function update_var_mode */


/*====================================

  C O P Y _ L I T S

  ====================================*/
void ExQuant::copy_lits(CUBE &toS,CUBE &fromS)
{
  
  for (uint i=0; i < fromS.size(); i++)   {
    int var_ind = abs(fromS[i])-1;
    if (present_in_table(var_ind,fromS[i]))  continue;

    insert_into_table(var_ind,fromS[i]);
    toS.push_back(fromS[i]);
  }


} /* end of function copy_lits */


/*============================================

  A D D _ N E W _ L I T E R A L S

  This function adds to E the literals
  of C that are
  a) literals of  X-variables
  b) literals of variables that are not
  already marked in the hash table.
      

  =============================================*/
inline void ExQuant::add_new_literals(CUBE &E,CUBE &C)
{
  CUBE &table = hash_table_lits.table;
  int marker = hash_table_lits.marker;

  for (uint i=0; i < C.size(); i++) {
    int var_ind = abs(C[i])-1;
    if (Var_state[var_ind].xvar == 0) continue;
    if (table[var_ind] == marker) continue;
    E.push_back(C[i]);
    table[var_ind] = marker;
  }

} /* end of function add_new_literals */

