#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <time.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>
using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"


/*================================

  R A N D _ X V A R _ A S S G N
        
  ===============================*/
int ExQuant::rand_xvar_assgn()
{

  int ntries;

  int num_free_xvars = Xvars.size() - num_assgn_xvars;
  ntries = 1 + (lrand48() % num_free_xvars);
  int count = 0;
  for (uint i=0; i <  Xvars.size (); i++)   {
    int var_ind = Xvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;
    if (++count == ntries) {
      if (lrand48() % 2 == 0) return(-(var_ind+1));
      else return(var_ind+1);
    }
  }
  assert(false);
} /* end of function rand_xvar_assgn */

/*============================================

  F I N D _ Y V A R _ A S S G N 5

  This is a light version of 'find_yvar_assgn3'
        
  ============================================*/
int ExQuant::find_yvar_assgn5()
{

  
  int max_val = -1;
  int best_var_ind = -1;

  int opt_scope = 20;
  int count = 0;
  bool first = true;
  int start = 0;
  if (prev_alg_state == BCP) 
    start = first_yvar_assigned;
 
 REPEAT:
  for (uint i=start; i <  Yvars.size (); i++)    {
    int var_ind = Yvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;
    if (first) {
      first_yvar_assigned = i;
      first = false;
    }
   
    int count0 = Lit_activity0[var_ind];
    int count1 = Lit_activity1[var_ind];
    
    
    int val = count0*count1+count0+count1;
   

    if (max_val < val)      {
      count = 0;
      max_val = val;
      best_var_ind = var_ind;
    }
    else count++;
    if (count > opt_scope) break;
  }
  
  if ((best_var_ind == -1) && (first_yvar_assigned > 0))   {
    start = 0;
    goto REPEAT;
  }


  if (best_var_ind == -1) return(0);
 
  if (Lit_activity0[best_var_ind] <
      Lit_activity1[best_var_ind])
    return(best_var_ind + 1);
  else 
    return(-(best_var_ind+1));
 
  
} /* end of function find_yvar_assgn5 */



/*==================================

  F I N D _ Y V A R _ A S S G N 3
        
  ==================================*/
int ExQuant::find_yvar_assgn3()
{

  int max_val = -1;
  int best_var_ind = -1;

  bool first = true;
  int start = 0;
  if (prev_alg_state == BCP) 
    start = first_yvar_assigned;

 REPEAT:
  for (uint i=start; i <  Yvars.size (); i++)  {
    int var_ind = Yvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;

    if (first)      {
      first_yvar_assigned = i;
      first = false;
    }

    int count0 = Lit_activity0[var_ind];
    int count1 = Lit_activity1[var_ind];
    
    int val = count0*count1;
    
    if (max_val < val)      {
      max_val = val;
      best_var_ind = var_ind;
    }
  }
  if ((best_var_ind == -1) && (first_yvar_assigned > 0))    {
    start = 0;
    goto REPEAT;
  }
  if (best_var_ind == -1) return(0);
  if (Lit_activity0[best_var_ind] <
      Lit_activity1[best_var_ind])
    return(best_var_ind + 1);
  else 
    return(-(best_var_ind+1));
 
  
} /* end of function find_yvar_assgn3 */

/*===================================

  F I N D _ Y V A R _ A S S G N 4
   
  ==================================*/
int ExQuant::find_yvar_assgn4()
{

  int max_val = -1;
  int best_var_ind = -1;

  for (uint i=0; i <  Sgnl_yvars.size (); i++)  {
    int var_ind = Sgnl_yvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;
    
    int count0 = Lit_activity0[var_ind];
    int count1 = Lit_activity1[var_ind];
    
    if (max_val < count0*count1)      {
      max_val = count0*count1;
      best_var_ind = var_ind;
    }
  }
  
  if (best_var_ind == -1)    {
    return(0);
    p(); 
    printf("gcount = %ld\n",gcount);
    printf("num_act_sgnl_cubes = %d\n",num_act_sgnl_cubes);
    cout << "Sgnl_yvars-> " << Sgnl_yvars << endl;
    print_Assgns_cut(Sgnl_yvars); 
    print_sgnl_cubes(true);
    exit(1);
  }

  if (Lit_activity0[best_var_ind] <
      Lit_activity1[best_var_ind])
    return(best_var_ind + 1);
  else 
    return(-(best_var_ind+1));
 
  
} /* end of function find_yvar_assgn4 */
