#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <time.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>
using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"

/*=======================================

  T R I V _ X V A R _ A S S G N
        
  =========================================*/
int ExQuant::triv_xvar_assgn()
{

  for (uint i=0; i <  Xvars.size (); i++)    {
    int var_ind = Xvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;     
    return(var_ind+1);
  }
  assert(false);
} /* end of function triv_xvar_assgn */

/*=======================================

  T R I V _ Y V A R _ A S S G N
        
  =========================================*/
int ExQuant::triv_yvar_assgn()
{

  for (uint i=0; i <  Yvars.size (); i++)    {
    int var_ind = Yvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;     
    return(var_ind+1);
  }
  assert(false);
} /* end of function triv_yvar_assgn */

/*================================================

  F I N D _ X V A R _ A S S G N 2

  Similar to 'find_yvar_assgn5' but is applied
  to X-variables        
  ==================================================*/
int ExQuant::find_xvar_assgn2()
{


  int max_val = -1;
  int best_var_ind = -1;


  int opt_scope = 100;
  int count = 0;
  int start = 0;
 
 
  for (uint i=start; i <  Xvars.size (); i++)  {
    int var_ind = Xvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;
     
     
    int count0 = Lit_activity0[var_ind];
    int count1 = Lit_activity1[var_ind];
    
    int val = count0*count1+count0+count1;
     
    if (max_val < val)    {
      count = 0;
      max_val = val;
      best_var_ind = var_ind;
    }
    else count++;
    if (count > opt_scope) break;
  }
  
  assert(best_var_ind >= 0);
  if (max_val == 0) return(0);
 
  if (Lit_activity0[best_var_ind] <
      Lit_activity1[best_var_ind])
    return(best_var_ind + 1);
  else 
    return(-(best_var_ind+1));
 
  
} /* end of function find_int_var_assgn2 */



/*=========================================

  A C T I V E _ C U B E _ C O U N T

  This function computes the number
  of "active" cubes of F listed in Cubes
  i.e. ones that are neither satified nor 
  redundant

  =========================================*/
int ExQuant::active_cube_count(CUBE &Cubes)
{

  int count = 0;
  for (uint i=0; i < Cubes.size(); i++)    {
    int cube_num = Cubes[i];
    if (Cube_info[cube_num].state == ACTIVE) count++;
  }
  return(count);

} /* end of function active_cube_count */


/*=======================================

  F I N D _ X V A R _ A S S G N 1
        
  =========================================*/
int ExQuant::find_xvar_assgn1()
{

  int max_prod = -1;
  int best_var_ind = -1;

  for (uint i=0; i <  Xvars.size (); i++)  {
    int var_ind = Xvars[i] - 1;
    if (Var_state[var_ind].val < 2) continue;
    int count0 = active_cube_count(Flits0[var_ind]);
    int count1 = active_cube_count(Flits1[var_ind]);
    if (max_prod < count0*count1)    {
      max_prod = count0*count1;
      best_var_ind = var_ind;
    }
  }
  
  if (best_var_ind == -1) return(0);
  assert(max_prod > 0);
  if (active_cube_count(Flits0[best_var_ind]) > 
      active_cube_count(Flits1[best_var_ind]))
    return(best_var_ind + 1);
  else 
    return(-(best_var_ind+1));
 
  
} /* end of function find_xvar_assgn1 */
