#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>
using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"

/*=============================

  P R I N T _ D S E Q 2

  ==========================*/
void ExQuant::print_dseq2(CUBE &S, int cube_ind)
{ 

  printf("(");
  for (uint i=0; i < S.size(); i++)    {
    int var_ind = abs(S[i])-1;
    if (S[i] < 0) printf("~");
    if (Var_state[var_ind].xvar) printf("x%d",var_ind+1);
    else printf("y%d",var_ind+1);
    if (i !=  S.size()-1) printf(" ");
  }
  printf(")");
  printf(" -> {%d}\n",cube_ind);
  
} /* end of function print_dseq2 */


/*============================

  P R I N T _ D S E Q 3

  ============================*/
void ExQuant::print_dseq3(int cube_ind)
{ 
  if (Cube_info[cube_ind].state != REDUNDANT) return;
  print_dseq2(Act_dseqs[cube_ind],cube_ind);
  
} /* end of function print_dseq3 */

/*=============================

  P R I N T _ C U B E

  ============================*/
void ExQuant::print_cube(int cube_ind)
{
  printf("Cube %d: ",cube_ind);
  print_cube1(F[cube_ind],true);

} /* end of function print_cube */


/*========================

  P R I N T _ C U B E 1

  =========================*/
void ExQuant::print_cube1(CUBE  &C,bool cr)
{
  for (uint i=0; i < C.size(); i++)  {
    if (i!= 0) printf(" ");
    int var_ind = abs(C[i])-1;
    if (Var_state[var_ind].xvar) 
      if (C[i] < 0) printf("~x%d",-C[i]);
      else printf("x%d",C[i]);
    else // Y-variable
      if (C[i] < 0) printf("~y%d",-C[i]);
      else printf("y%d",C[i]);
  }

  if (cr) printf("\n");

} /* end of function print_cube1 */


/*================================================

  R E A L _ N U M _ A S S G N _ I N T _ V A R S

  ===============================================*/
int ExQuant::real_num_assgn_int_vars()
{

  int count = 0;
  for (uint i=0; i < Xvars.size();i++)
    if (Var_state[Xvars[i]-1].val < 2)
      count++;

  return(count);
} /* end of function real_num_assgn_int_vars */

/*========================================

  P R I N T _ A S S G N S _ C U T 2

  =======================================*/
void  ExQuant::print_Assgns_cut2(CUBE &C)
{

  for (uint i=0; i < C.size();i++)   {
    int lit = C[i];
    int var_ind = abs(lit)-1;
    if (i > 0) printf(" ");
    if (lit < 0) printf("~");
    if (Var_state[var_ind].xvar) printf("x%d",var_ind+1);
    else printf("y%d",var_ind+1);

    if (Var_state[var_ind].val == 2) continue;
    int val=0;
    if (lit > 0) val = 1;
    if (val != value(var_ind))
      printf("(s,%d)",Var_sel_depth[var_ind]);
    else
      printf("(f,%d)",Var_sel_depth[var_ind]);
  }
  printf("\n");

} /* end of function print_Assgns_cut2 */
/*=======================================

  P R I N T _ S G N L _ C U B E S

  ========================================*/
void ExQuant::print_sgnl_cubes(bool active)
{
  if (active) 
    printf("Current active signal cubes: \n");
  else
    printf("Current signal cubes: \n");
  for (uint i=0; i < F.size(); i++)  {
    if (Cube_info[i].signal == 0) continue;
    if (active && (Cube_info[i].state != ACTIVE)) continue;
    printf("F[%d]: ",i);
    print_Assgns_cut2(F[i]);
    print_cube_state(i);
  }

} /* end of function print_sgnl_cubes */

/*===================================

  P R I N T _ S G N L  _ S T A T U S

  =================================*/
void ExQuant::print_sgnl_status(int cube_ind,bool depth_flag,int shift)
{

  for (int i=0; i < shift; i++)
    printf(" ");
  printf("Cube_info[%d].signal = %d\n",cube_ind,Cube_info[cube_ind].signal);
  if (Cube_info[cube_ind].signal && depth_flag)   {
    for (int i=0; i < shift; i++)
      printf(" ");
    printf("Cube_info[%d].depth=%d\n",cube_ind,Cube_info[cube_ind].depth);
  }
 
} /* end of function print_sgnl_status */

/*=======================================

  P R I N T _ C U B E _ T Y P E

  ========================================*/
void ExQuant::print_cube_type(int cube_ind)
{

  assert((int) Cube_info.size() > cube_ind);
  switch (Cube_info[cube_ind].type)    {
  case INITIAL:
    printf("INITIAL\n");
    break;
  case Y_CUBE:
    printf("Y_CUBE\n");
    break;
  case X_CUBE:
    printf("X_CUBE\n");
    break;
  case NONE:
    printf("NONE\n");
    break;
  default:
    assert(false);
  }


} /* end of function print_cube_type */

