#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <string.h>
using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"
	


/*============================================

         N U M _ S G N L _ C U B E S

  =============================================*/
int ExQuant::num_sgnl_cubes(CUBE &Cubes)
{
  int count = 0;
  for (uint i=0; i < Cubes.size(); i++)
    if (Cube_info[Cubes[i]].signal) count++;

  return(count);
} /* end of function num_sgnl_cubes */

/*===================================

   S E T _ I N I T _ C O U N T S

 ===================================*/
void ExQuant::set_init_counts()
{

  for (int i=0; i < num_vars; i++)  {
    Act_sgnl_cubes_cnt0[i] = num_sgnl_cubes(Flits0[i]);
    Act_sgnl_cubes_cnt1[i] = num_sgnl_cubes(Flits1[i]);

    if (Act_sgnl_cubes_cnt0[i] + Act_sgnl_cubes_cnt1[i] > 0) {
      if (Var_state[i].xvar)
        add_xvar_to_array(i);
      else
        add_yvar_to_array(i);
    }
  }


} /* end of function set_init_counts */



/*=====================================

   F O R M _ X V A R S _ Y V A R S

 =====================================*/
void ExQuant::form_Xvars_Yvars()
{


  int shift = 0;

  for (uint i=0; i < Yvars.size(); i++) {
    int var_ind = Yvars[i]-1;
    assert(var_ind < num_vars);
    if (missing_var(var_ind)) {
      shift++;
      continue;
    }

    if (shift > 0)
      Yvars[i-shift] = Yvars[i];

  }

  if (shift > 0) Yvars.resize(Yvars.size() - shift);


  // mark Yvars 


  for (uint i=0; i < Yvars.size(); i++) {
    int var_ind = Yvars[i]-1;
    Var_state[var_ind].xvar = 0;}


  // form Xvars
  Xvars.clear();

  for (int i=0; i < num_vars; i++) {
    if (missing_var(i)) {
      num_missing_vars++;
      continue;
    }

    if (Var_state[i].xvar) Xvars.push_back(i+1);
  }


} /* end of function form_Xvars_Yvars */

/*======================================

     I N I T _ S O L V E R _ S T A T E

 =======================================*/
void ExQuant::init_solver_state()
{
  verbose = false;
  xvar_dec_mode = XVAR_MAX_ACT_SGNL_CUBES;
  yvar_dec_mode = YVAR_LIT_ACTIVITY5;
  seed_value = 0;
  max_num_dseqs = MAX_NUM_DSEQS;
  dec_making_flag = false;
  cnfl_cube_flag = 0;
  strcpy(res_root_name,"");
  extra_stat_flag = false;
  empty_init_sgnl_cubes = false;
  prot_media_cubes = true;
  rigor_check = true;
  just_check_sgnl_cubes = false;
  ign_wrong_yvars = false;
  res_dseqs_flag = false;
  max_num_ycubes = -1;
  first_yvar_assigned = 0;
  time_limit = 1000000;
  prepr_mode = false;
  prepr_bcp = false;
  prepr_red_cubes = false;
  noise = true;
  start_gcount = -1;
  range_gcount = -1;

} /* end of function init_solver_state */

/*==========================================

 A S S G N _ I N I T _ P R O T _ C U B E S

 ============================================*/
bool ExQuant::assgn_init_prot_cubes()
{
   
  CUBE Red_cubes;
  for (uint i=0; i < F.size(); i++)    {
    if (Cube_info[i].state != ACTIVE) continue;
      
    int lit;
    bool success = fnd_ping_cubes(i,lit);
    if (success) continue; 

    // new redundant cube is found 
    CUBE S;
    num_frw_blocked_cube_dseqs++;
    set_new_act_dseq(i,S,false);
      
    // this D-sequent is unconditional, so no reason to 
    // update Late_seq_inds
      
    check_red_cube_in(i,lit,-1,true);
    Red_cubes.push_back(i);
  }

 
  check_for_new_red_cubes(Red_cubes);  

  num_frw_blocked_cube_dseqs0 = num_frw_blocked_cube_dseqs;

 
  prot_media_cubes = false;
  return(num_act_sgnl_cubes == 0);

} /* end of function assgn_init_prot_cubes */
