#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
//
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <assert.h>
#include <strings.h>
#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

using namespace std;
#include "d0s_pqe.hh"
#include "einline.hh"

/*===========================

     F P R I N T _ C U B E

  ==========================*/
void fprint_cube(FILE *fp,CUBE &C)
{
  for (uint i=0; i < C.size(); i++) {
    if (i > 0) fprintf(fp," ");
    fprintf(fp,"%d",C[i]);
  }
  if (C.size() == 0) fprintf(fp,"0\n");
  else fprintf(fp," 0\n");
} /* end of function fprint_cube */

/*============================

   P R I N T _ D N F

=============================*/
void print_dnf(DNF &D,char *fname,int num_vars)

{ FILE *fp;

  fp = fopen(fname,"w");
  if (fp == NULL)  {
    p();
    cout << "cannot open file " << fname << endl;
    exit(1);
  }
   
  fprintf(fp,"p cnf %d %d\n",num_vars,(int) D.size());
  for (uint i = 0; i < D.size();i++)
    fprint_cube(fp,D[i]);

  fclose(fp);
} /* end of function print_dnf */


/*=============================

   O P E R A T O R < <

   for the CUBE type
 
=============================*/
ostream &operator<<(ostream &os,CUBE const &v)
{
  CUBE:: const_iterator i;
  for (i=v.begin();i!= v.end();i++)
    if (i == v.begin()) cout << *i;
    else cout << " " << *i;
  return(os);
}

/*==============================

   F I N D _ M A X _ V A R

===============================*/
int find_max_var(DNF &D)

{
  int max=0;

  for (uint i = 0; i < D.size();i++) {
    CUBE &C = D[i];
    for (uint j = 0; j < C.size();j++)
      if (abs(C[j]) >  max)
        max = abs(C[j]);
  }
  
  return(max);

} /* end of function find_max_var */


/*=====================

   P R I N T _ D N F

======================*/
void print_dnf(DNF &D)
{
 printf("p cnf %d %d\n",find_max_var(D),(int) D.size());
 for (uint i = 0; i < D.size();i++)
   fprint_cube(stdout,D[i]);
} /* end of function print_dnf */


