#include <iostream>
#include <list>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <time.h>
#include <algorithm>
#include <ctime>
#include <climits>
#include <cassert>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

using namespace std;
#include "d0s_pqe.hh"

/*========================================

        R E A D _ I N T _ N U M 

  ======================================*/
int read_int_num(char *Num_str)
{


  char Buff[MAX_NAME];

  assert(strlen(Num_str) < MAX_NAME);

  int init_cnt=0;
  int res_cnt = 0;
  while (true)    {
    char symb = Num_str[init_cnt++];
    if ((symb >= '0') && (symb <= '9'))    {
      Buff[res_cnt++] = symb;
      continue;
    }
    if (symb == ',') continue;

    if (symb == 0)   {
      Buff[res_cnt++] = 0;
      break;
    }
    assert(false);
  }

  return(atoi(Buff));

} /* end of function read_int_num */

/*==========================================

   P R I N T _ P R E P R _ R E S U L T S 1

   This function is called to print out
   results after preprocessing
 ==========================================*/
void ExQuant::print_prepr_results1()
{

  char fname[MAX_NAME];
 

// print out Y-variables
  strcpy(fname,res_root_name);
  strcat(fname,".txt");
  print_out_array(fname,Yvars);

  // print out the formula
  strcpy(fname,res_root_name);
  strcat(fname,".cnf");
  print_dnf(F,fname,num_vars);

  // print out initial signal cubes
  strcpy(fname,res_root_name);
  strcat(fname,".clauses");
  print_out_array(fname,Init_sgnl_cubes);
  

} /* end of function print_prepr_results1 */



/*==========================================

   P R I N T _ P R E P R _ R E S U L T S 2


 ==========================================*/
void ExQuant::print_prepr_results2()
{

  char fname[MAX_NAME];
 

// print out Y-variables
  strcpy(fname,res_root_name);
  strcat(fname,".txt");
  print_out_array(fname,Yvars);

  // form formula and signal cubes
  DNF D;
  CUBE Sgnl_cubes;
  for (uint i=0; i < F.size(); i++)   {
    if (Cube_info[i].state != ACTIVE)  continue;     
    D.push_back(F[i]);
    if (Cube_info[i].signal) Sgnl_cubes.push_back(D.size()-1);
  }

  // print out the formula
  strcpy(fname,res_root_name);
  strcat(fname,".cnf");
  print_dnf(D,fname,num_vars);

  // print out the signal cubes
  strcpy(fname,res_root_name);
  strcat(fname,".clauses");
  print_out_array(fname,Sgnl_cubes);


} /* end of function print_prepr_results2 */




/*=======================================

    P R I N T _ O U T _ A R R A Y

  =====================================*/
void ExQuant::print_out_array(char *fname,CUBE &Ext_vars)
{

  FILE *fp = fopen(fname,"w");
  assert(fp != NULL);

  for(uint i=0; i < Ext_vars.size();i++)   {
    if (i!= 0) fprintf(fp," ");
    fprintf(fp,"%d",Ext_vars[i]);
  }

  fprintf(fp,"\n");
  fclose(fp);

} /* end of funciton print_out_array */
